Index: java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 105)
@@ -9,13 +9,12 @@
 import com.framsticks.communication.queries.UseRequest;
 import com.framsticks.communication.queries.VersionRequest;
-import com.framsticks.core.Path;
 import com.framsticks.params.ListSource;
+import com.framsticks.structure.Path;
 import com.framsticks.util.*;
 import com.framsticks.util.dispatching.AtOnceDispatcher;
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Future;
-import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.JoinableState;
 import com.framsticks.util.lang.Casting;
@@ -195,5 +194,5 @@
 	}
 
-	private void sendNextUseRequest(final Iterator<String> featuresIterator, final Future<Void> future) {
+	private void sendNextUseRequest(final Iterator<String> featuresIterator, final FutureHandler<Void> future) {
 		if (!featuresIterator.hasNext()) {
 			future.pass(null);
@@ -214,5 +213,5 @@
 	}
 
-	private void sendQueryVersion(final int version, final Future<Void> future) {
+	private void sendQueryVersion(final int version, final FutureHandler<Void> future) {
 		send(new VersionRequest().version(version), new ClientSideResponseFuture(future) {
 			@Override
@@ -335,5 +334,5 @@
 		}
 
-		final Future<File> future = new Future<File>() {
+		final FutureHandler<File> future = new FutureHandler<File>() {
 
 			protected void send(final File result) {
@@ -415,5 +414,5 @@
 	}
 
-	protected final ExceptionResultHandler closeOnFailure = new ExceptionResultHandler() {
+	protected final ExceptionHandler closeOnFailure = new ExceptionHandler() {
 
 		@Override
@@ -428,5 +427,5 @@
 		startClientConnection(this);
 
-		sendQueryVersion(1, new FutureHandler<Void>(closeOnFailure) {
+		sendQueryVersion(1, new Future<Void>(closeOnFailure) {
 
 			@Override
@@ -451,5 +450,5 @@
 	protected final Map<String, EventListener<File>> registeredListeners = new HashMap<>();
 
-	public <C> void addListener(String path, final EventListener<File> listener, final Dispatcher<C> dispatcher, final Future<Void> future) {
+	public <C> void addListener(String path, final EventListener<File> listener, final Dispatcher<C> dispatcher, final FutureHandler<Void> future) {
 		send(new RegisterRequest().path(path), dispatcher, new ClientSideResponseFuture(future) {
 			@Override
@@ -463,5 +462,5 @@
 	}
 
-	public <C> void removeListener(EventListener<File> listener, final Dispatcher<C> dispatcher, final Future<Void> future) {
+	public <C> void removeListener(EventListener<File> listener, final Dispatcher<C> dispatcher, final FutureHandler<Void> future) {
 		String eventPath = null;
 		synchronized (registeredListeners) {
Index: java/main/src/main/java/com/framsticks/communication/ClientSideRawConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientSideRawConnection.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/communication/ClientSideRawConnection.java	(revision 105)
@@ -2,5 +2,5 @@
 
 import com.framsticks.params.annotations.FramsClassAnnotation;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.dispatching.RunAt;
 
@@ -23,5 +23,5 @@
 	}
 
-	public void send(final String line, ExceptionResultHandler handler) {
+	public void send(final String line, ExceptionHandler handler) {
 
 		senderThread.dispatch(new RunAt<ClientSideRawConnection>(handler) {
Index: java/main/src/main/java/com/framsticks/communication/ClientSideResponseFuture.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ClientSideResponseFuture.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/communication/ClientSideResponseFuture.java	(revision 105)
@@ -1,11 +1,11 @@
 package com.framsticks.communication;
 
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
 
-public abstract class ClientSideResponseFuture extends FutureHandler<Response> {
+public abstract class ClientSideResponseFuture extends Future<Response> {
 
-	public ClientSideResponseFuture(ExceptionResultHandler handler) {
+	public ClientSideResponseFuture(ExceptionHandler handler) {
 		super(handler);
 	}
Index: java/main/src/main/java/com/framsticks/communication/Connection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/communication/Connection.java	(revision 105)
@@ -5,4 +5,5 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.io.Encoding;
@@ -25,5 +26,4 @@
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
@@ -35,5 +35,5 @@
 
 @FramsClassAnnotation
-public abstract class Connection extends AbstractJoinable implements JoinableParent, ExceptionResultHandler {
+public abstract class Connection extends AbstractJoinable implements JoinableParent, ExceptionHandler {
 
 	protected final static Logger log = LogManager.getLogger(Connection.class);
@@ -52,5 +52,5 @@
 	protected final Set<ConnectionListener> listeners = new HashSet<>();
 
-	protected ExceptionResultHandler exceptionHandler = ThrowExceptionHandler.getInstance();
+	protected ExceptionHandler exceptionHandler = ThrowExceptionHandler.getInstance();
 
 	/**
@@ -301,5 +301,5 @@
 	 * @return the handler
 	 */
-	public ExceptionResultHandler getExceptionHandler() {
+	public ExceptionHandler getExceptionHandler() {
 		return exceptionHandler;
 	}
@@ -308,5 +308,5 @@
 	 * @param handler the handler to set
 	 */
-	public void setExceptionHandler(ExceptionResultHandler handler) {
+	public void setExceptionHandler(ExceptionHandler handler) {
 		this.exceptionHandler = handler;
 	}
@@ -346,5 +346,5 @@
 	}
 
-	public final void sendFile(final String header, final File file, final Integer id, ExceptionResultHandler handler) {
+	public final void sendFile(final String header, final File file, final Integer id, ExceptionHandler handler) {
 		senderThread.dispatch(new RunAt<Connection>(handler) {
 			@Override
Index: java/main/src/main/java/com/framsticks/communication/File.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/File.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/communication/File.java	(revision 105)
@@ -1,6 +1,4 @@
 package com.framsticks.communication;
 
-import java.util.ArrayList;
-import java.util.List;
 
 import javax.annotation.Nonnull;
@@ -31,10 +29,4 @@
 	}
 
-	public static List<File> single(File file) {
-		List<File> result = new ArrayList<File>();
-		result.add(file);
-		return result;
-	}
-
 	@Override
 	public String toString() {
Index: java/main/src/main/java/com/framsticks/communication/RequestHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/RequestHandler.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/communication/RequestHandler.java	(revision 105)
@@ -2,10 +2,10 @@
 
 import com.framsticks.communication.queries.ApplicationRequest;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.ExceptionHandler;
 
 /**
  * @author Piotr Sniegowski
  */
-public interface RequestHandler extends ExceptionResultHandler {
+public interface RequestHandler extends ExceptionHandler {
 	public void handle(ApplicationRequest request, ServerSideResponseFuture responseCallback);
 }
Index: java/main/src/main/java/com/framsticks/communication/Response.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/Response.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/communication/Response.java	(revision 105)
@@ -1,4 +1,5 @@
 package com.framsticks.communication;
 
+import java.util.Arrays;
 import java.util.List;
 
@@ -10,4 +11,8 @@
 	protected final String comment;
 	protected final List<File> files;
+
+	public Response(boolean ok, String comment, File... files) {
+		this(ok, comment, (files.length == 0 ? null : Arrays.asList(files)));
+	}
 
 	public Response(boolean ok, String comment, List<File> files) {
Index: java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 105)
@@ -46,5 +46,5 @@
 		if (request instanceof ProtocolRequest) {
 			if (request instanceof VersionRequest) {
-				responseCallback.pass(new Response(true, null, null));
+				responseCallback.pass(new Response(true, null));
 				return;
 			}
@@ -53,16 +53,16 @@
 				if (feature.equals("request_id")) {
 					requestIdEnabled = true;
-					responseCallback.pass(new Response(true, null, null));
+					responseCallback.pass(new Response(true, null));
 					return;
 				}
 				if (feature.equals("call_empty_result")) {
-					responseCallback.pass(new Response(true, null, null));
+					responseCallback.pass(new Response(true, null));
 					return;
 				}
 				if (feature.equals("needfile_id")) {
-					responseCallback.pass(new Response(true, null, null));
+					responseCallback.pass(new Response(true, null));
 					return;
 				}
-				responseCallback.pass(new Response(false, "unknown feature: " + feature, null));
+				responseCallback.pass(new Response(false, "unknown feature: " + feature));
 				return;
 			}
@@ -70,5 +70,5 @@
 		}
 		log.error("unhandled request: {}", request);
-		responseCallback.pass(new Response(false, "unhandled", null));
+		responseCallback.pass(new Response(false, "unhandled"));
 	}
 
@@ -120,5 +120,5 @@
 			e.arg("id", id.get()).arg("line", line);
 			log.error("error: ", e);
-			respond(new Response(false, "invalid input: " + e.getMsg(), null), id.get());
+			respond(new Response(false, "invalid input: " + e.getMsg()), id.get());
 			return;
 		}
Index: java/main/src/main/java/com/framsticks/communication/ServerSideResponseFuture.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/ServerSideResponseFuture.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/communication/ServerSideResponseFuture.java	(revision 105)
@@ -2,14 +2,14 @@
 
 import com.framsticks.util.FramsticksException;
-import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
 
 /**
  * @author Piotr Sniegowski
  */
-public abstract class ServerSideResponseFuture extends Future<Response> {
+public abstract class ServerSideResponseFuture extends FutureHandler<Response> {
 
 	@Override
 	public final void handle(FramsticksException e) {
-		result(new Response(false, e.getClass().getCanonicalName() + ": " + e.getMessage(), null));
+		result(new Response(false, e.getClass().getCanonicalName() + ": " + e.getMessage()));
 	}
 
Index: java/main/src/main/java/com/framsticks/communication/queries/NeedFile.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/NeedFile.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/communication/queries/NeedFile.java	(revision 105)
@@ -2,5 +2,5 @@
 
 import com.framsticks.communication.File;
-import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.lang.Strings;
 
@@ -9,5 +9,5 @@
 	protected final String suggestedName;
 	protected final String description;
-	protected final Future<File> future;
+	protected final FutureHandler<File> future;
 
 	/**
@@ -16,5 +16,5 @@
 	 * @param future
 	 */
-	public NeedFile(String suggestedName, String description, Future<File> future) {
+	public NeedFile(String suggestedName, String description, FutureHandler<File> future) {
 		this.suggestedName = suggestedName;
 		this.description = description;
@@ -39,5 +39,5 @@
 	 * @return the future
 	 */
-	public Future<File> getFuture() {
+	public FutureHandler<File> getFuture() {
 		return future;
 	}
Index: java/main/src/main/java/com/framsticks/communication/queries/RegisterRequest.java
===================================================================
--- java/main/src/main/java/com/framsticks/communication/queries/RegisterRequest.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/communication/queries/RegisterRequest.java	(revision 105)
@@ -1,5 +1,5 @@
 package com.framsticks.communication.queries;
 
-import com.framsticks.core.Path;
+import com.framsticks.structure.Path;
 import com.framsticks.util.lang.Pair;
 
Index: java/main/src/main/java/com/framsticks/dumping/LoadStream.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 105)
@@ -2,10 +2,10 @@
 
 import com.framsticks.communication.File;
-import com.framsticks.core.TreeOperations;
-import com.framsticks.core.Path;
 import com.framsticks.params.ListSource;
-import com.framsticks.core.Tree;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
+import com.framsticks.structure.TreeOperations;
 import com.framsticks.util.*;
-import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.lang.Pair;
 import com.framsticks.util.lang.Strings;
@@ -28,9 +28,9 @@
 	protected final Path mountPath;
 	protected final BufferedReader stream;
-	protected final Future<Path> future;
+	protected final FutureHandler<Path> future;
 	protected final Stopwatch stopwatch = new Stopwatch();
 
 
-	public LoadStream(Path mountPath, BufferedReader stream, Tree tree, Future<Path> future) {
+	public LoadStream(Path mountPath, BufferedReader stream, Tree tree, FutureHandler<Path> future) {
 		this.tree = tree;
 		this.mountPath = mountPath;
Index: java/main/src/main/java/com/framsticks/dumping/SaveStream.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 105)
@@ -1,8 +1,5 @@
 package com.framsticks.dumping;
 
-import static com.framsticks.core.TreeOperations.*;
 import static com.framsticks.params.AccessOperations.*;
-import com.framsticks.core.Node;
-import com.framsticks.core.Path;
 import com.framsticks.params.Access;
 import com.framsticks.params.CompositeParam;
@@ -11,8 +8,10 @@
 import com.framsticks.params.Sink;
 import com.framsticks.parsers.Savers;
-import com.framsticks.core.Tree;
+import com.framsticks.structure.Node;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
 import com.framsticks.util.*;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.FutureHandler;
 
 import org.apache.logging.log4j.Logger;
@@ -22,4 +21,6 @@
 import java.util.HashSet;
 import java.util.Set;
+
+import static com.framsticks.structure.TreeOperations.*;
 import static com.framsticks.util.lang.Containers.filterInstanceof;
 
@@ -33,5 +34,5 @@
 	protected final Sink sink;
 	protected final Tree tree;
-	protected final Future<Void> future;
+	protected final FutureHandler<Void> future;
 	protected final Stopwatch stopwatch = new Stopwatch();
 	protected final Set<FramsClass> storedInfo = new HashSet<FramsClass>();
@@ -39,5 +40,5 @@
 	private int dispatched = 0;
 
-	public SaveStream(Sink sink, Tree tree, Path root, Future<Void> future) {
+	public SaveStream(Sink sink, Tree tree, Path root, FutureHandler<Void> future) {
 		assert Dispatching.isThreadSafe();
 		this.sink = sink;
Index: java/main/src/main/java/com/framsticks/experiment/Experiment.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/Experiment.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/experiment/Experiment.java	(revision 105)
@@ -7,5 +7,4 @@
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.core.ListChange;
 import com.framsticks.params.EventListener;
 import com.framsticks.params.ParamFlags;
@@ -16,4 +15,6 @@
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.remote.RemoteTree;
+import com.framsticks.structure.messages.ListChange;
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.AbstractJoinable;
@@ -22,5 +23,4 @@
 import com.framsticks.util.dispatching.DispatcherSetable;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
@@ -30,5 +30,5 @@
 
 @FramsClassAnnotation
-public class Experiment extends AbstractJoinable implements Dispatcher<Experiment>, DispatcherSetable<Experiment>, JoinableParent, ExceptionResultHandler {
+public class Experiment extends AbstractJoinable implements Dispatcher<Experiment>, DispatcherSetable<Experiment>, JoinableParent, ExceptionHandler {
 	private static final Logger log = LogManager.getLogger(Experiment.class);
 
Index: java/main/src/main/java/com/framsticks/experiment/NetLoadSaveLogic.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/NetLoadSaveLogic.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/experiment/NetLoadSaveLogic.java	(revision 105)
@@ -5,12 +5,12 @@
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.core.ListChange;
-import com.framsticks.core.Message;
 import com.framsticks.params.EventListener;
 import com.framsticks.params.MessageLogger;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.structure.messages.ListChange;
+import com.framsticks.structure.messages.Message;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Future;
-import com.framsticks.util.dispatching.FutureHandler;
 
 @FramsClassAnnotation
@@ -50,5 +50,5 @@
 
 				log.debug("issuing netsave to: {}", simulator);
-				simulator.netsave(netJavaClass, new FutureHandler<NF>(simulator) {
+				simulator.netsave(netJavaClass, new Future<NF>(simulator) {
 
 					@Override
@@ -68,5 +68,5 @@
 		}
 		log.debug("issuing netload to: {}", simulator);
-		netload(simulator, new FutureHandler<NF>(simulator) {
+		netload(simulator, new Future<NF>(simulator) {
 
 			@Override
@@ -77,5 +77,5 @@
 				}
 
-				simulator.netload(net, new FutureHandler<Object>(this) {
+				simulator.netload(net, new Future<Object>(this) {
 
 					@Override
@@ -90,5 +90,5 @@
 	}
 
-	public abstract void netload(Simulator simulator, Future<NF> net);
+	public abstract void netload(Simulator simulator, FutureHandler<NF> net);
 
 	public abstract void netsave(Simulator simulator, NF net);
Index: java/main/src/main/java/com/framsticks/experiment/Simulator.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/Simulator.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/experiment/Simulator.java	(revision 105)
@@ -4,8 +4,4 @@
 import com.framsticks.communication.queries.NeedFile;
 import com.framsticks.communication.queries.NeedFileAcceptor;
-import com.framsticks.core.ListChange;
-import com.framsticks.core.Path;
-import com.framsticks.core.Tree;
-import com.framsticks.core.ValueChange;
 import com.framsticks.params.AccessOperations;
 import com.framsticks.params.CastFailure;
@@ -19,11 +15,15 @@
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.remote.RemoteTree;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
+import com.framsticks.structure.messages.ListChange;
+import com.framsticks.structure.messages.ValueChange;
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Future;
-import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableParent;
@@ -35,8 +35,10 @@
 import org.apache.logging.log4j.LogManager;
 import org.apache.logging.log4j.Logger;
-import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.params.ParamsUtil.arguments;
+import static com.framsticks.params.ParamsUtil.getParam;
+import static com.framsticks.structure.TreeOperations.*;
 
 @FramsClassAnnotation
-public final class Simulator extends AbstractJoinable implements Dispatcher<Simulator>, JoinableParent, UniqueObject, ExceptionResultHandler {
+public final class Simulator extends AbstractJoinable implements Dispatcher<Simulator>, JoinableParent, UniqueObject, ExceptionHandler {
 
 	private static final Logger log = LogManager.getLogger(Simulator.class);
@@ -69,5 +71,5 @@
 			public void action(ValueChange argument) {
 				try {
-					boolean running = simulatorClass.getParamEntry("running", BooleanParam.class).reassign(argument.value, null).getValue();
+					boolean running = getParam(simulatorClass, "running", BooleanParam.class).reassign(argument.value, null).getValue();
 					log.debug("running state of {} changed: {}", Simulator.this, running);
 					if (!running) {
@@ -80,5 +82,5 @@
 		};
 
-		addListener(simulatorPath, simulatorClass.getParamEntry("running_changed", EventParam.class), runningListener, ValueChange.class, new FutureHandler<Void>(this) {
+		addListener(simulatorPath, getParam(simulatorClass, "running_changed", EventParam.class), runningListener, ValueChange.class, new Future<Void>(this) {
 			@Override
 			protected void result(Void result) {
@@ -160,5 +162,5 @@
 	public void start() {
 		log.debug("starting simulator {}", this);
-		call(simulatorPath, "start", new Object[] {}, Object.class, FutureHandler.doNothing(Object.class, this));
+		call(simulatorPath, "start", arguments(), Object.class, Future.doNothing(Object.class, this));
 	}
 
@@ -199,5 +201,5 @@
 	protected final AtomicInteger netloadIdCounter = new AtomicInteger();
 
-	public <N> void netload(final N net, final Future<Object> future) {
+	public <N> void netload(final N net, final FutureHandler<Object> future) {
 		final String netloadId = "NetLoadSaveLogic" + netloadIdCounter.getAndIncrement();
 
@@ -231,9 +233,9 @@
 		simulatorPath.getTree().addNeedFileAcceptor(Integer.MIN_VALUE, acceptor.get());
 
-		call(simulatorPath, getFramsClass(simulatorPath).getParamEntry("netload_id", ProcedureParam.class), new Object[] { netloadId }, Object.class, new FutureHandler<Object>(future) {
+		call(simulatorPath, getParam(simulatorPath, "netload_id", ProcedureParam.class), arguments(netloadId), Object.class, new Future<Object>(future) {
 
 			@Override
 			protected void result(Object result) {
-				log.debug("upload of {} done", file);
+				log.debug("netload of {} done", file);
 				future.pass(result);
 			}
@@ -242,14 +244,13 @@
 	}
 
-	public <N> void netsave(Class<N> netJavaClass, final Future<N> futureNet) {
-		call(simulatorPath, getFramsClass(simulatorPath).getParamEntry("netsave", ProcedureParam.class), new Object[] { }, netJavaClass, new FutureHandler<N>(futureNet) {
+	public <N> void netsave(Class<N> netJavaClass, final FutureHandler<N> futureNet) {
+		call(simulatorPath, getParam(simulatorPath, "netsave", ProcedureParam.class), arguments(), netJavaClass, new Future<N>(futureNet) {
 
 			@Override
 			protected void result(N net) {
-				log.debug("download of {} done", net);
+				log.debug("netsave of {} done", net);
 				futureNet.pass(net);
 			}
 		});
-
 	}
 }
Index: java/main/src/main/java/com/framsticks/experiment/SimulatorConnector.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/SimulatorConnector.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/experiment/SimulatorConnector.java	(revision 105)
@@ -6,17 +6,17 @@
 
 import com.framsticks.communication.Address;
-import com.framsticks.core.Path;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.remote.RemoteTree;
+import com.framsticks.structure.Path;
 import com.framsticks.util.AutoAttacher;
 import com.framsticks.util.Misc;
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Strings;
 
-import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.structure.TreeOperations.*;
 
 @FramsClassAnnotation
@@ -46,5 +46,5 @@
 		Dispatching.dispatchLog(remoteTree, log, Level.DEBUG, "first task in remote tree");
 
-		tryGet(remoteTree, "/simulator", new FutureHandler<Path>(experiment) {
+		tryGet(remoteTree, "/simulator", new Future<Path>(experiment) {
 
 			@Override
Index: java/main/src/main/java/com/framsticks/experiment/StandardNetFile.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/StandardNetFile.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/experiment/StandardNetFile.java	(revision 105)
@@ -0,0 +1,9 @@
+package com.framsticks.experiment;
+
+public class StandardNetFile implements NetFile {
+
+	@Override
+	public String getShortDescription() {
+		return "standard.expdef netfile";
+	}
+}
Index: java/main/src/main/java/com/framsticks/experiment/WorkPackageLogic.java
===================================================================
--- java/main/src/main/java/com/framsticks/experiment/WorkPackageLogic.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/experiment/WorkPackageLogic.java	(revision 105)
@@ -8,6 +8,4 @@
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.core.Message;
-import com.framsticks.core.ValueChange;
 import com.framsticks.params.EventListener;
 import com.framsticks.params.MessageLogger;
@@ -15,6 +13,8 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.structure.messages.Message;
+import com.framsticks.structure.messages.ValueChange;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Future;
-import com.framsticks.util.dispatching.FutureHandler;
 
 @FramsClassAnnotation(order = {"netLoadSaveLogic", "newestTaskScheduled", "newestResultReceived"})
@@ -47,9 +47,9 @@
 
 			@Override
-			public void netload(final Simulator simulator, final Future<WP> netFuture) {
+			public void netload(final Simulator simulator, final FutureHandler<WP> netFuture) {
 				assert experiment.isActive();
 				log.debug("providing netload file for {}", simulator);
 
-				findNextPackage(new FutureHandler<WP> (netFuture) {
+				findNextPackage(new Future<WP> (netFuture) {
 
 					@Override
@@ -106,5 +106,5 @@
 
 
-	protected void findNextPackage(final Future<WP> future) {
+	protected void findNextPackage(final FutureHandler<WP> future) {
 		if (!queuedPackages.isEmpty()) {
 			WP workPackage = queuedPackages.pollFirst();
@@ -113,5 +113,5 @@
 		}
 
-		generateNextPackage(new FutureHandler<WP>(experiment) {
+		generateNextPackage(new Future<WP>(experiment) {
 
 			@Override
@@ -127,5 +127,5 @@
 	}
 
-	protected abstract void generateNextPackage(Future<WP> future);
+	protected abstract void generateNextPackage(FutureHandler<WP> future);
 	protected abstract void returnPackage(WP workPackage);
 
